#include <bits/stdc++.h>
using namespace std;
using ll = long long;
struct point {
    int a, b, c;
};
int cnt = 0;
void dfs(vector<vector<int>> &q,vector<bool> &used,int j,int count) {
    used[j] = true;
    if (cnt==count) {
        return;
    }
    for (auto i : q[j]) {
        if (!used[i]) {
            cnt++;
            dfs(q,used,i,count);
        }
    }
    cnt--;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m,k;
    cin >> n >> m >> k;
    vector<vector<int>> q(n);
    for (int i = 0;i<m;i++) {
        int a,b;
        cin >> a >> b;
        a--;
        b--;
        q[a].push_back(b);
        q[b].push_back(a);
    }
    vector<bool> used(n);
    for (int i = 0;i<k;i++) {
        int p,h;
        cin >> p >> h;
        p--;
        dfs(q,used,p,h);
    }
    int ans = 0;
    for (int i = 0;i<n;i++) {
        if (used[i]) {
            ans++;
        }
    }
    if (ans==0) {
        cout << "";
        return 0;
    }
    cout << ans << endl;
    for (int i = 0;i<n;i++) {
        if (used[i]) {
            cout << i+1 << " ";
        }
    }

    return 0;
}